#include <bits/stdc++.h>
using namespace std;
int sm(int*d,int l,int r){
    return d[r+1]-d[l];
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    int a[n];
    for(int i=0;i<n;i++){
        cin>>a[i];
    }
    if(n==3){
        cout<<max(max(a[0],a[1]),a[2])-min(min(a[0],a[1]),a[2])<<'\n';
        cout<<"1 2 3\n";
        return 0;
    }
    int p[n+1];
    p[0]=0;
    for(int i=0;i<n;i++){
        p[i+1]=p[i]+a[i];
    }
    int mn=INT32_MAX;
    int mnx,mny,mnz;
    for(int x=0;x<n;x++){
        for(int y=x+1;y<n;y++){
            for(int z=y+1;z<n;z++){
                int a=sm(p,x,y-1),b=sm(p,y,z-1),c;
                if(x!=0)c=sm(p,z,n-1)+sm(p,0,x-1);
                else c=sm(p,z,n-1);
                int cur=max(max(a,b),c)-min(min(a,b),c);
                if(mn>cur){
                    mn=cur;
                    mnx=x+1;
                    mny=y+1;
                    mnz=z+1;
                }
                if(mn==0){
                    cout<<0<<'\n';
                    cout<<mnx<<" "<<mny<<" "<<mnz<<'\n';
                    return 0;
                }
            }
        }
    }
    cout<<mn<<'\n';
    cout<<mnx<<" "<<mny<<" "<<mnz;
}
